/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_StressTestTerminationReasons;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_StressTestTerminationReasons;


/**
 * This class represents StressTestTerminationReasons_CID3221
 */
public class StressTestTerminationReasons_CID3221 
{
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new StressTestTerminationReasons_CID3221 Template 
	 */
	public StressTestTerminationReasons_CID3221()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumStressTestTerminationReasons Object of EnumCM_StressTestTerminationReasons represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_StressTestTerminationReasons enumStressTestTerminationReasons)
	{
		switch(enumStressTestTerminationReasons)
		{
		case CHEST_PAIN: this.strCodeValue =EnumCV_StressTestTerminationReasons.CHEST_PAIN_F_37000.getValue(); break;
		case ABNORMAL_ECG: this.strCodeValue =EnumCV_StressTestTerminationReasons.ABNORMAL_ECG_F_38002.getValue(); break;
		case FATIGUE: this.strCodeValue =EnumCV_StressTestTerminationReasons.FATIGUE_F_01360.getValue(); break;
		case DYSPNEA: this.strCodeValue =EnumCV_StressTestTerminationReasons.DYSPNEA_F_201B3.getValue(); break;
		case PATIENT_REFUSED_EXERCISE_TEST: this.strCodeValue =EnumCV_StressTestTerminationReasons.PATIENT_REFUSED_EXERCISE_TEST_R_214DD.getValue(); break;
		case TARGET_HEART_RATE_ACHIEVED: this.strCodeValue =EnumCV_StressTestTerminationReasons.TARGET_HEART_RATE_ACHIEVED_F_021E1.getValue(); break;
		case HYPOTENSIVE_EPISODE: this.strCodeValue =EnumCV_StressTestTerminationReasons.HYPOTENSIVE_EPISODE_D3_04001.getValue(); break;
		case HYPERTENSIVE_EPISODE: this.strCodeValue =EnumCV_StressTestTerminationReasons.HYPERTENSIVE_EPISODE_D3_02004.getValue(); break;
		case ARRHYTHMIA: this.strCodeValue =EnumCV_StressTestTerminationReasons.ARRHYTHMIA_D3_30000.getValue(); break;
		case CLAUDICATION: this.strCodeValue =EnumCV_StressTestTerminationReasons.CLAUDICATION_F_18010.getValue(); break;
		case END_OF_PROTOCOL: this.strCodeValue =EnumCV_StressTestTerminationReasons.END_OF_PROTOCOL_R_4038D.getValue(); break;
		case SYNCOPE: this.strCodeValue =EnumCV_StressTestTerminationReasons.SYNCOPE_D3_00006.getValue(); break;

		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumStressTestTerminationReasons Object of EnumCM_StressTestTerminationReasons represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_StressTestTerminationReasons enumStressTestTerminationReasons)
	{
		switch(enumStressTestTerminationReasons)
		{
		case CHEST_PAIN: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.CHEST_PAIN.getSNOMEDCTID(); break;
		case ABNORMAL_ECG: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ABNORMAL_ECG.getSNOMEDCTID(); break;
		case FATIGUE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.FATIGUE.getSNOMEDCTID(); break;
		case DYSPNEA: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.DYSPNEA.getSNOMEDCTID(); break;
		case PATIENT_REFUSED_EXERCISE_TEST: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.PATIENT_REFUSED_EXERCISE_TEST.getSNOMEDCTID(); break;
		case TARGET_HEART_RATE_ACHIEVED: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.TARGET_HEART_RATE_ACHIEVED.getSNOMEDCTID(); break;
		case HYPOTENSIVE_EPISODE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.HYPOTENSIVE_EPISODE.getSNOMEDCTID(); break;
		case HYPERTENSIVE_EPISODE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.HYPERTENSIVE_EPISODE.getSNOMEDCTID(); break;
		case ARRHYTHMIA: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ARRHYTHMIA.getSNOMEDCTID(); break;
		case CLAUDICATION: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.CLAUDICATION.getSNOMEDCTID(); break;
		case END_OF_PROTOCOL: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.END_OF_PROTOCOL.getSNOMEDCTID(); break;
		case SYNCOPE: this.strSNOMEDCTID =EnumDICOMSNOMEDMap.SYNCOPE.getSNOMEDCTID(); break;
		
		}
	}

	/**
	 * Sets the value for StressTestTerminationReasons
	 * @param enumStressTestTerminationReasons Object of EnumCM_StressTestTerminationReasons.
	 */
	public void setStressTestTerminationReasons(EnumCM_StressTestTerminationReasons enumStressTestTerminationReasons)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumStressTestTerminationReasons.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumStressTestTerminationReasons);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumStressTestTerminationReasons);
	}
}
